package com.company.mavenproject1;

import java.io.*;
import javax.decorator.*;
import javax.enterprise.inject.Any;
import javax.inject.Inject;

@Decorator
public class BanneredPrinter implements Printer {

    private final Printer printer;

    public @Inject BanneredPrinter(final @Delegate @Any Printer printer) {
        if (null == (this.printer = printer)) throw new NullPointerException();
    }

    public void print(final Job job) throws IOException {
        printer.print(new Job() {
            public void feed(final PrintStream out) throws IOException {
                out.println("---------- BEGIN PRINT ----------");
                job.feed(out);
                out.println("----------  END PRINT  ----------");
            }
        });
    }
}
